// A simple player that just tries to hit children on the opponent's
// team with snowballs.
//
// Feel free to use this as a starting point for your own player.

// 	java -jar icypc.jar -player java java_example.Eko36 -player java java_example.Eko41

// ICPC Challenge
// Sturgill, Baylor University

package java_example;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.Random;
import java.awt.Point;
import java.util.Collections;
import java.lang.Math;
import java.util.PriorityQueue;

import java.io.*;

  class Dijk implements Comparable<Dijk>{
	int sdist;
	double edist;
	int x,y;
	
	public int tx, ty;
	public Dijk (int sdist, double edist, int x, int y, int tx, int ty) { this.sdist = sdist; this.edist = edist; this.x=x; this.y=y; this.tx=tx; this.ty=ty;  };
	public Dijk (int sdist, double edist, int x, int y) { this.sdist = sdist; this.edist = edist; this.x=x; this.y=y; this.tx=-1; this.ty=-1;  };
	public Dijk () { };
	public int compareTo (Dijk b) { 
		if ((this.sdist + this.edist) > (b.sdist + b.edist))
			return 1;
		if ((this.sdist + this.edist) == (b.sdist + b.edist))
			return 0;

		return -1;
	}
  };


public class Eko87f {
  // Constant used to mark child locations in the map.
 
  public static int[][] height = new int [ Const.SIZE ][ Const.SIZE ];
  public static int[][] ground = new int [ Const.SIZE ][ Const.SIZE ];
  
  public static List<Point> bonecos = new ArrayList<Point>();
  public static List<Point> bonecos_inimigos = new ArrayList<Point>();
  
  public static int jogadas = 0;
  public static int acertos = 0;
  public static int tentativas = 0;
  public static int pegadas = 0;
  public static int tontos = 0;
  public static int ele_pegador = 0;
  
    public static boolean area_dominada_2(Child a){
	  Point bu;
	  
	  if (a.pos.x<3 || a.pos.x>Const.SIZE-4 || a.pos.y<3 || a.pos.y>Const.SIZE-4 )	//Evita de construir mto proximo as bordas
		  return true;
	  if (a.pos.x>12 && a.pos.x<18 && a.pos.y>12 && a.pos.y<18 )	//Evita de construir no meio
		  return true;
	  
	  int dist_min=8;	//distancia minima inicial
	  for (int i = 0; i < bonecos.size();i++){
		bu = bonecos.get(i);

		double dist = dist_eucli(a.pos,bu);

		if (dist>14)	//Se t muito longe, continua	
			continue;
		
		if(dist<dist_min)	// Se distancia menor que a minima, retorna que area j est dominada 		
			return true;
		else			// Seno aumenta distancia minima
			dist_min++;
		
	  }
	  
	return false;	  
  }
  
    public static Point ladrao(Child a){
	  Point bu;
	  int dx,dy;
	  int menor=100;
	  Point retorno_menor=null;
	  
	  for (int i = 0; i < bonecos_inimigos.size();i++){
		bu = bonecos_inimigos.get(i);
		dx = a.pos.x - bu.x;
		dy = a.pos.y - bu.y;
		if ((dx * dx + dy * dy)<menor){
			menor=(dx * dx + dy * dy);
			retorno_menor = bu;
		}		
	  }	  
	  if (menor<=52 && a.holding!=Const.HOLD_S3)		// Tem um boneco inimigo proximo e as mos livres?
		  return retorno_menor;
	  else
		  return null;	  
  }
  
  public static Point socorro_2(Child a,Child[] cList){

	  double menor=10;
	  double aux;
	  Point retorno_menor=null;
	  
	  for ( int i = Const.CCOUNT; i < Const.CCOUNT * 2; i++ ) {
		  Child c = cList[ i ];
		  if ( c.pos.x >= 0 && c.dazed==0 ){	//se  visivel e nao esta stun 
			  aux = dist_eucli(a.pos,c.pos); 
			  if(aux<menor){
				  menor=aux;
				  retorno_menor=c.pos;
			  }
		  }
	  }
	  
	  if (menor<10)	// Quem precisa de ajuda, est proximo??
		  return  new Point (retorno_menor.x,retorno_menor.y);
	  else
		  return null;	  
  }

  
  private static int sum(int x,int top){
	  if (x<top)
		  return x;
	  else
		  return top;	  
  }
  
    private static boolean dispersa(Point pos, int turnNum){
	    if (ground[pos.x][pos.y]==-1 || turnNum < 9)
		    return true;
	    else{
		    int rand = rnd.nextInt(99);
		    if (rand<30)
			return true;		    
	    }
	    return false;
  }
  
  public static int menor_somatoria(List fila) {
	  int[] somatoria = new int[4];
	  for (int i=0;i<4;i++)
		  if (fila.get(i)=="H" || fila.get(i)=="X")
			  somatoria[i]=1000;
		  else
			  somatoria[i]=Integer.parseInt((String)fila.get(i));
	;	  
	int menor2 = 1000;
	int index = -1;
	for (int i=0;i<4;i++){
		if(somatoria[i]<menor2){
			menor2=somatoria[i];
			index=i;				// indice do alvo mais proximo
		}
	}
	return index;
  }
  
  private static void atribui_vitima(Child[] cList){
	int[][] dst=new int[4][4];

	dst[0][0]=distancia_3(cList[0],cList[4]);dst[0][1]=distancia_3(cList[0],cList[5]);dst[0][2]=distancia_3(cList[0],cList[6]);dst[0][3]=distancia_3(cList[0],cList[7]);
	dst[1][0]=distancia_3(cList[1],cList[4]);dst[1][1]=distancia_3(cList[1],cList[5]);dst[1][2]=distancia_3(cList[1],cList[6]);dst[1][3]=distancia_3(cList[1],cList[7]);
	dst[2][0]=distancia_3(cList[2],cList[4]);dst[2][1]=distancia_3(cList[2],cList[5]);dst[2][2]=distancia_3(cList[2],cList[6]);dst[2][3]=distancia_3(cList[2],cList[7]);
	dst[3][0]=distancia_3(cList[3],cList[4]);dst[3][1]=distancia_3(cList[3],cList[5]);dst[3][2]=distancia_3(cList[3],cList[6]);dst[3][3]=distancia_3(cList[3],cList[7]);
	
	
	
//	System.err.println("--XX--");
//	System.err.println(dst[0][0]+","+dst[0][1]+","+dst[0][2]+","+dst[0][3]);
//	System.err.println(dst[1][0]+","+dst[1][1]+","+dst[1][2]+","+dst[1][3]);
//	System.err.println(dst[2][0]+","+dst[2][1]+","+dst[2][2]+","+dst[2][3]);
//	System.err.println(dst[3][0]+","+dst[3][1]+","+dst[3][2]+","+dst[3][3]);
	PO po = new PO(dst);
//	po.print();
	
	for (int i=0;i<4;i++){
		cList[i].alvo=po.c[i][0];
		    
		cList[i].victimPri=po.cinfo[i][0];
		cList[i].victimNext=po.cinfo[i][1];
		
		if (cList[i].alvo>=4)
			cList[i].victimFound=true;
		else
			cList[i].victimFound=false;
	}
	  
  }

  // Simple representation for a child in the game.
  static class Child {
    // Location of the child.
    Point pos = new Point();

    // True if  the child is standing.
    boolean standing;
    int temNeve;

    // Side the child is on.
    int color;

    // What's the child holding.
    int holding;
    int holding_ant;

    // How many more turns this child is dazed.
    int dazed;
    
    boolean victimFound;
    boolean victimNext;
    boolean victimPri;
    //Numero da criana alvo
    int alvo;
    boolean eh_alvo;
    
    int constroi_boneco;
    
    String action = "idle";
    Point dest = null;
    Point rouba = null;
    
    private int controi_boneco(int[][] height,int[][] ground){
	    // Try to acquire a snowball if we need one.
	    if(this.acha_lugar_boneco(height,ground,false,false)==1 && this.holding != Const.HOLD_S2 && this.holding != Const.HOLD_S3  ){		    
		    if ( this.holding != Const.HOLD_L ) {
			    if ( this.holding == Const.HOLD_S1 || this.holding == Const.HOLD_M ){	//Se tiver segurando uma bolinha, solta
				    this.acha_lugar_boneco(height,ground,true,true);			    
				    this.action = "drop";				    
			    }else{
				    // Crush into a snowball, if we have snow.
				    if ( this.holding == Const.HOLD_P3 ) {
					    this.action = "crush";
				    } else {
					    if (this.acha_neve(height,ground))
						    this.pega_neve();
					    
				    }
			    }
		    }else{
			    this.acha_lugar_boneco(height,ground,true,false);			    
			    this.action = "drop";
		    }	
		    return 1;
	    }else
	    if(this.acha_lugar_boneco(height,ground,false,false)==2  && this.holding != Const.HOLD_S2 && this.holding != Const.HOLD_S3  ){		    
		    if ( this.holding != Const.HOLD_M ) {
			    if ( this.holding == Const.HOLD_S1){	//Se tiver segurando uma bolinha, solta
				    this.acha_lugar_boneco(height,ground,true,true);			    
				    this.action = "drop";				    
			    }else{
				    // Crush into a snowball, if we have snow.
				    if ( this.holding == Const.HOLD_P2 ) {
					    this.action = "crush";
				    } else {
					    if (this.acha_neve(height,ground))
						    this.pega_neve();
					    
				    }
			    }
		    }else{
			    this.acha_lugar_boneco(height,ground,true,false);			    
			    this.action = "drop";
		    }	
		    return 2;
	    }else
	    	mula_sem_cabeca();
	    
	    
	    return 0;
    }
    
    private int acha_lugar_boneco(int[][] height,int[][] ground,boolean destino,boolean pula_um){
	    // We don't have snow, see if there is some nearby.
	    int sx = -1, sy = -1;
	    int place = -1;
	    for ( int ox = this.pos.x + 1; ox >= this.pos.x - 1; ox-- )
	    for ( int oy = this.pos.y + 1; oy >= this.pos.y - 1; oy-- ) {
		    if(pula_um){
			    pula_um=false;
			    continue;
		    }
		    // Is there snow to pick up?
		    if ( ox >= 0 && ox < Const.SIZE && oy >= 0 && oy < Const.SIZE &&
		    ( ox != this.pos.x || oy != this.pos.y ) && height[ ox ][ oy ] < 9 &&
		    (ground[ ox ][ oy ] == Const.GROUND_EMPTY || ground[ ox ][ oy ] == Const.GROUND_L || ground[ ox ][ oy ] == Const.GROUND_LM) ) {

			    if (ground[ ox ][ oy ]> place){
				sx = ox;
				sy = oy;
				place = ground[ ox ][ oy ];
			    }
		    }
	    }
	    if(place==-1)
		return 0;
	    if (destino)
		this.dest = new Point( sx, sy );
	    if (height[ sx ][ sy ] <= 3 && ground[ sx ][ sy ] == Const.GROUND_EMPTY)
		return 1;
	    if (ground[ sx ][ sy ] == Const.GROUND_L)
		return 2;
	    if (ground[ sx ][ sy ] == Const.GROUND_LM)
		return 3;
	    
	    return 0;	    
    }
    
    private boolean acha_neve(int[][] height,int[][] ground){
	    // We don't have snow, see if there is some nearby.
	    int sx = -1, sy = -1;
	    
	    for ( int ox = this.pos.x + 1; ox >= this.pos.x - 1; ox-- )
	    for ( int oy = this.pos.y + 1; oy >= this.pos.y - 1; oy-- ) {
		    // Is there snow to pick up?
		    if ( ox >= 0 && ox < Const.SIZE &&
			 oy >= 0 && oy < Const.SIZE &&
		    ( ox != this.pos.x || oy != this.pos.y ) &&
		    ground[ ox ][ oy ] == Const.GROUND_EMPTY &&
		    height[ ox ][ oy ] > 0 && ground[ ox ][ oy ] != Const.GROUND_OCUPADO) {
			    sx = ox;
			    sy = oy;
			    this.dest = new Point( sx, sy );
			    ground[ ox ][ oy ] = Const.GROUND_OCUPADO;
			    return true;
		    }
	    }    
	    return false;	    
    }
    
    private int conta_neve(){
	    // We don't have snow, see if there is some nearby.
	    int sx = -1, sy = -1;
	    int cont=0;
	    
	    for ( int ox = this.pos.x + 1; ox >= this.pos.x - 1; ox-- )
	    for ( int oy = this.pos.y + 1; oy >= this.pos.y - 1; oy-- ) {

		    if ( ox >= 0 && ox < Const.SIZE &&
			 oy >= 0 && oy < Const.SIZE &&
		    ( ox != this.pos.x || oy != this.pos.y ) &&
		    ground[ ox ][ oy ] == Const.GROUND_EMPTY &&
		    height[ ox ][ oy ] > 0 && ground[ ox ][ oy ] != Const.GROUND_OCUPADO) {
			  cont+=height[ ox ][ oy ];
		    }
	    }    
	    return cont;	    
    }
    
        private boolean roubando(){		// Faz o ato de roubar a cabea
		
	Point dot = ladrao(this);
	if (dot!=null){
	int dx = this.pos.x - dot.x;
	int dy = this.pos.y - dot.y;
	int dst = dx * dx + dy * dy;
	if (dst<=2 && (this.holding==Const.HOLD_S1 || this.holding==Const.HOLD_S2 || this.holding==Const.HOLD_EMPTY)){	// Se ta encostado e pode pegar, rouba							
									
		if ( this.holding == Const.HOLD_P1 ) {
			this.action = "crush";
		} else {
			if (this.rouba_boneco()){
				this.pega_neve();
			}else
				return false;
		}
		
	   bonecos_inimigos.remove(bonecos_inimigos.indexOf(dot));
	   return true;
	}}
	return false;
    }
    
    private boolean acha_bolinha(){
	    // We don't have snow, see if there is some nearby.
	    int sx = -1, sy = -1;
	    for ( int ox = this.pos.x + 1; ox >= this.pos.x - 1; ox-- )
	    for ( int oy = this.pos.y + 1; oy >= this.pos.y - 1; oy-- ) {
		    // Is there snow to pick up?
		    if ( ox >= 0 && ox < Const.SIZE && oy >= 0 && oy < Const.SIZE &&
		    ( ox != this.pos.x || oy != this.pos.y ) && 
		    ground[ ox ][ oy ] == Const.GROUND_S) {
			    sx = ox;
			    sy = oy;
			    this.dest = new Point( sx, sy );
			    return true;
		    }
	    }    
	    return false;	    
    }
    
    private boolean rouba_boneco(){
	    // We don't have snow, see if there is some nearby.
	    int sx = -1, sy = -1;
	    for ( int ox = this.pos.x + 1; ox >= this.pos.x - 1; ox-- )
	    for ( int oy = this.pos.y + 1; oy >= this.pos.y - 1; oy-- ) {
		    // Is there snow to pick up?
		    if ( ox >= 0 && ox < Const.SIZE && oy >= 0 && oy < Const.SIZE &&
		    ( ox != this.pos.x || oy != this.pos.y ) &&
		    ground[ ox ][ oy ] == Const.GROUND_SMB ) {
			    sx = ox;
			    sy = oy;
			    this.dest = new Point( sx, sy );
			    return true;
		    }
	    }    
	    return false;	    
    }
    
    private boolean mula_sem_cabeca(){		// Procura e poem cabea nas mulas
	    
	    if(this.acha_lugar_boneco(height,ground,false,false)==3){		    
		    if ( this.holding != Const.HOLD_S1 && this.holding != Const.HOLD_S2 && this.holding != Const.HOLD_S3 ) {
			    // Crush into a snowball, if we have snow.
			    if ( this.holding == Const.HOLD_P1 ) {
				    this.action = "crush";
			    } else {
				    if (this.acha_bolinha())
					    this.pega_neve();
				    else
					    if (this.acha_neve(height,ground))
						    this.pega_neve();
				    
			    }
		    }else{
			    this.acha_lugar_boneco(height,ground,true,false);			    
			    this.action = "drop";
			    bonecos.add(this.dest);
			//    System.err.println("Boneco criado em: "+this.dest);
		    }	
		    return true;
	    }	 
	    return false;
    }

    
    private boolean pega_neve(){
	    
	    if ( this.standing ) {
		    this.action = "crouch";
		    this.dest = null;	
		    return false;
	    } else if (this.holding==Const.HOLD_S3 || this.holding==Const.HOLD_M || this.holding==Const.HOLD_L){	// Se ta com as maos cheias
		    this.action = "drop";
		    return false;	    
	    } else {
		    this.action = "pickup";
		    return true;
	    }    
    }
    
    private boolean canCatch(Child c){
	if (c.dazed==0 && (c.holding==Const.HOLD_S1 || c.holding==Const.HOLD_S2 || c.holding==Const.HOLD_EMPTY))
		return true;
	else
		return false;
	    
    }
    
    private boolean catcher(Child[] cList,boolean defencivo){
              // Try to find a Perigo.
              boolean perigoFound = false;
	      Point retorno_alvo=null;
	      if (defencivo){
		      if (this.canCatch(this)){	// Se eu posso pegar
			      for ( int j = Const.CCOUNT; !perigoFound && j < Const.CCOUNT * 2; j++ ) {				// Se ele tem condies de jogar
				if ( cList[ j ].pos.x >= 0 && cList[ j ].dazed==0 && (cList[ j ].holding==Const.HOLD_S1 || cList[ j ].holding==Const.HOLD_S2 || cList[ j ].holding==Const.HOLD_S3 ) ) {
				  int dx = this.pos.x - cList[ j ].pos.x;
				  int dy = this.pos.y - cList[ j ].pos.y;
				 // int dsq = dx * dx + dy * dy;
				  if ( throw_perfeito_2(cList[ j ],new Point( cList[ j ].pos.x+dx*2,cList[ j ].pos.y+dy*2),this )< Const.MAX_THROW/2.5 ) {		// Se ele pode me acertar
					  if (perigoFound)		// Se ta true tem mais de um, se tem mais de um, n tem como saber qeum vai jogar
						  return false;
					  
					  perigoFound = true;
	
					  // throw past the victim, so we will probably hit them
					  // before the snowball falls into the snow.
					  retorno_alvo = new Point( cList[ j ].pos.x,
								    cList[ j ].pos.y );
				  }
				}
			      }
		      }
		      if (perigoFound){
			      this.action = "catch";
			      this.dest = retorno_alvo;
			      tentativas++;
			      return true;		      
		      }
		}

		return false;
    }
    
    
private static float throw_perfeito_2(Child atacante,Point dest,Child alvo){
	int dx = dest.x - atacante.pos.x;
	int dy = dest.y - atacante.pos.y;	
	int AMIGO,INIMIGO;
	
	if (atacante.color==Const.RED){			// Deixa generico o throw_perfeito
		AMIGO=Const.GROUND_CHILD_MINHA;
		INIMIGO=Const.GROUND_CHILD_DELE;
	}else{
		AMIGO=Const.GROUND_CHILD_DELE;
		INIMIGO=Const.GROUND_CHILD_MINHA;
	}

	
	float n = Math.max(Math.abs(dx),Math.abs(dy));
	float M = dx*dx+dy*dy;
	//System.err.println("--------------------- Throw: "+M);
	if (M<Const.MAX_THROW){		//  perto 24*24
		
	
		int finalX=0;
		int finalY=0;
		int h=9;
		if (!atacante.standing)
			h=6;
	
		for(int i=1;i<=n;i++){			
			finalX = (atacante.pos.x+round(i*dx/n));
			finalY = (atacante.pos.y+round(i*dy/n));
			int altura=h-Math.round(9*i/n);
		//	System.err.println(">"+finalX+","+finalY+":"+altura);
			if ( finalX >= 0 && finalX < Const.SIZE && finalY >= 0 && finalY < Const.SIZE ){
				if (ground[ finalX ][ finalY ] == Const.GROUND_TREE)
					break;
				
				if (ground[ finalX ][ finalY ] == AMIGO){
					//System.err.println(" AMIGOO!!!!!!!!!!!! "+n);
					break;
				}
			
				if (ground[ finalX ][ finalY ] == INIMIGO && alvo.pos.x==finalX && alvo.pos.y==finalY){
				//	System.err.println("--------------------- retorna: "+M);
					return M;	
				}
				
				if (height[ finalX ][ finalY ]>=altura)	{	// 	Caiu antes
				//	System.err.println(" CAI antes!!!!!!!!!!!!!!!!!!!!!! "+n);
					break;
				}

			}
			
		}
	}
	return Const.MAX_THROW;

}

private boolean anda_pouquinho(Child[] cList, boolean lado){

	int dx = cList[ this.alvo ].pos.x - this.pos.x;
	int dy = cList[ this.alvo ].pos.y - this.pos.y;
	
	
	
	if (lado){
		if (!nextTo(this.pos.x,this.pos.y, cList[ this.alvo ].pos.x,cList[ this.alvo ].pos.y))
			moveToward_2(this,new Point(cList[ this.alvo ].pos.x, cList[ this.alvo ].pos.y),true);
		else
			moveToward_2(this,new Point(this.pos.x+2, this.pos.y+2),true);
		
		return true;
	}else{
		if ( !this.standing)
			this.action = "stand";
		else
			moveToward_2(this,new Point(this.pos.x+dx, this.pos.y+dy),false);
		return true;	
	}

}

private boolean defencivo(int[] score,double fator){

	float rand = rnd.nextFloat();
	
	if (score[0]>=score[1]){
		if (rand<fator)
	//	if (rand<fator+(1-fator)/2.0)		// se ta ganhando, da menos importancia ao fator
			return true;
	}else
		if (rand<0.7*fator)
			return true;


	return false;
}
    
    private boolean atira_no_alvo(Child[] cList){
	    if ( cList[ this.alvo ].pos.x >= 0 ) {
		    int dx = cList[ this.alvo ].pos.x - this.pos.x;
		    int dy = cList[ this.alvo ].pos.y - this.pos.y;
		    
		    
			int Mul = 3;
			
			for (int i=5;i>=2;i--){
				int ddx = dx*i;
				int ddy = dy*i;
				if (ddx*ddx+ddy*ddy<Const.MAX_THROW){
					Mul=i;
					break;
				}
			}
		    
		    int finalX;
		    int finalY;
		    if (this.standing){
			    finalX=this.pos.x+dx*2;
			    finalY=this.pos.y+dy*2;
		    }else{
			    finalX=this.pos.x+dx*Mul;
			    finalY=this.pos.y+dy*Mul;    
		    }
		    if ( throw_perfeito_2(this,new Point( finalX,finalY),cList[ this.alvo ]) < Const.MAX_THROW ) {

			    this.action = "throw";			    
			    this.dest = new Point( finalX, finalY );
			    
			    jogadas++;
			    cList[ this.alvo ].eh_alvo=true;
			    
			    return true;


		    }
		    else{
			if ( !this.standing) {
			//	System.err.println(" DE PEEEEEEEE ");
				this.action = "stand";
			}else{
			    this.victimFound = false;
			    this.alvo=-1;
			}
		    }			    
	    }
	    return false;
    }
    
    
 }

  /** Source of randomness for this player. */
  static Random rnd = new Random();

  
  static boolean obstaculo (Point w){
	if( w.x < 0 || w.x >= Const.SIZE || w.y < 0 || w.y >= Const.SIZE )
		return true;
	
	if (height[ w.x ][ w.y ] > 5)
		return true;

	if (ground[ w.x ][ w.y ] > 0){
		//System.err.println("<<<<<<<<<<Obstaculo "+ground[ w.x ][ w.y ]);
		return true;
	}
	
	return false;
  }

  /** Fill in m to move the child twoard the given target location, either
      crawling or running. */
      
  static int getManhattanDist(int x1, int y1, int x2, int y2) {
	  return Math.abs(x1 - x2) + Math.abs(y1 - y2);
  }      
  // determines if a child at (x1, y1) can crawl once to be next to (x2, y2).
  // Not the same as the other way around
  

  static boolean withinCrawlingDistance(int x1, int y1, int x2, int y2) {
	  return !((x1 == x2 && y1 == y2) || Math.abs(x1 - x2) + Math.abs(y1 - y2) > 1 || obstaculo(new Point(x2, y2)));
  }

  static boolean withinRunningDistance(int x1, int y1, int x2, int y2) {
	if ((x1 == x2 && y1 == y2) || Math.abs(x1 - x2) + Math.abs(y1 - y2) > 2 || obstaculo(new Point(x2, y2))) {
		return false;
	} else if (Math.abs(x1 - x2) <= 1 && Math.abs(y1 - y2) <= 1) {
		return !obstaculo(new Point(x2, y2));
	} else {
		return !obstaculo(new Point(x2, y2)) && !obstaculo(new Point((x1 + x2) / 2, (y1 + y2) / 2));
	}
  }

      
  static void moveToward_2( Child c, Point target, boolean stopNextTo) {
	  
	boolean[][] visited = new boolean[Const.SIZE][Const.SIZE];
	visited[c.pos.x][c.pos.y] = true;
	
	//priority_queue<Dijk> q;
	PriorityQueue<Dijk> q = new PriorityQueue<Dijk>();
	q.add(new Dijk( 0, getManhattanDist(c.pos.x, c.pos.y, target.x, target.y) / (c.standing ? 2 : 1), c.pos.x, c.pos.y) );
	
	while (q.size()>0) {
		//Dijk d = q.top();
		//q.pop();
		
		Dijk d = q.poll();
		//System.err.println(q.size()+":"+d.x+","+d.y+">>"+target.x+","+target.y);
		
		//if ((d.x == target.x && d.y == target.y) || q.size()>7000) {	// J chegou
		if ((stopNextTo && nextTo(d.x, d.y, target.x, target.y)) || (!stopNextTo && d.x == target.x && d.y == target.y) || q.size()>7000) {

			int moveX = d.tx == -1 ? d.x : d.tx;
			int moveY = d.ty == -1? d.y : d.ty;
		    
			//System.err.println("Dijk >>"+moveX+","+moveY+":"+q.size());
			
				if (c.standing) {
					c.action = "run";
					c.dest = new Point(moveX, moveY);
				} else {
					c.action = "crawl";
					c.dest = new Point(moveX, moveY);
				}
				
			if (Math.abs(moveX - c.pos.x) == 2 || Math.abs(moveY - c.pos.y) == 2) {
				ground[ (moveX + c.pos.x)/2 ][ (moveY + c.pos.y)/2 ] = Const.GROUND_OCUPADO; 
			}
				
				return;
		}
		
		for (int j = d.x - 2; j <= d.x + 2; j++) {
			for (int k = d.y - 2; k <= d.y + 2; k++) {
				if (c.standing) {
					if (withinRunningDistance(d.x, d.y, j, k)) {
						q.add(new Dijk(d.sdist + 1, (double)getManhattanDist(j, k, target.x, target.y) / 2.0, j, k, d.tx == -1? j : d.tx, d.ty == -1? k : d.ty));
					}
				} else {
					if (withinCrawlingDistance(d.x, d.y, j, k)) {
						q.add(new Dijk(d.sdist + 1, getManhattanDist(j, k, target.x, target.y), j, k, d.tx == -1? j : d.tx, d.ty == -1? k : d.ty));
					}
				}
			}
		}
	}
	  
  }
      


  public static void main( String[] args ) {
    // Current game score for self (red) and opponent (blue).
    int[] score = new int [ 2 ];

    // List of children on the field, half for each team.    
    Child[] cList = new Child [ 2 * Const.CCOUNT ];
    for ( int i = 0; i < cList.length; i++ ){
	    cList[ i ] = new Child ();
	    cList[ i ].victimFound=false;
	    cList[ i ].alvo=-1;
    }

    // Scanner to parse input from the game engine.
    Scanner in = new Scanner( System.in );

    // Random destination for each player.
    Point[] runTarget = new Point [ Const.CCOUNT ];
    for ( int i = 0; i < runTarget.length; i++ )
      runTarget[ i ] = new Point();
    
    // How long the child has left to run toward its destination.
    int[] runTimer = new int [ Const.CCOUNT ];

    // Keep reading states until the game ends.
    int turnNum = in.nextInt();
    
    // ############### Inicio deterministico
    
    int timeToGo = 9;
    boolean stopNextTo = false;
    
    runTimer[0]=timeToGo+1;
    runTarget[0]=new Point(5,16);//4,14
    
    runTimer[1]=5;
    runTarget[1]=new Point(4,4);
    
    runTimer[2]=timeToGo;
    runTarget[2]=new Point(11,14);
    
    runTimer[3]=timeToGo+1;
    runTarget[3]=new Point(16,5);//14,4
    
    
    
		    //Loop
		    while ( turnNum >= 0 ) {
			float th = jogadas==0? 0 : acertos/(float)jogadas*100; 
			float pg = tentativas==0? 0 : pegadas/(float)tentativas*100;
			System.err.println("Turno "+turnNum+" ------["+score[0]+"]-["+score[1]+"]------: Throws: "+acertos+"/"+jogadas+" ");
			//System.err.format("%.1f%% he cat %d",th,ele_pegador);
			//System.err.print(" Pegadas:"+pegadas+"/"+tentativas+">"+tontos+" ");
			//System.err.format("%.1f%%",pg);
			//System.err.println("");
			double fator = tentativas<30? 1 : (pegadas/(float)tentativas>=0.1? 1 : pegadas/(float)tentativas/0.1);
			if (fator==0 && tentativas<45)		// corrige, possivel estagnao do fator em 0
				fator=tontos/(float)turnNum;
			
		//	System.err.format("Fator %.2f \n",fator);
		//	System.err.format("Fator Throw %.2f \n",fator_throw);
			
		    	// Read current game score.
			score[ Const.RED ] = in.nextInt();
			score[ Const.BLUE ] = in.nextInt();
			
			stopNextTo = false;
			
			String token;
			bonecos_inimigos.clear(); 
			// Parse the current map.
		      for ( int i = 0; i < Const.SIZE; i++ ) {
			for ( int j = 0; j < Const.SIZE; j++ ) {
			  // Can we see this cell?
			  token = in.next();
			  if ( token.charAt( 0 ) == '*' ) {
			    height[ i ][ j ] = -1;
			    ground[ i ][ j ] = -1;
			  } else {
			    height[ i ][ j ] = token.charAt( 0 ) - '0';
			    ground[ i ][ j ] = token.charAt( 1 ) - 'a';
			    if (token.charAt( 1 )=='j'){
				    bonecos_inimigos.add(new Point (i,j));
				//    System.err.println("Boneco inimigo em: "+new Point (i,j));
				    
			    }
			  }
			}
		      }
		
		      // Read the states of all the children.
		      for ( int i = 0; i < Const.CCOUNT * 2; i++ ) {
			Child c = cList[ i ];
			
			// Can we see this child?        
			token = in.next();
			if ( token.equals( "*" ) ) {
				c.pos.x = -1;
				c.pos.y = -1;
			} else {
				
			  // Record the child's location.
			  c.pos.x = Integer.parseInt( token );
			  c.pos.y = in.nextInt();
		
			  // Compute child color based on it's index.
			  c.color = ( i < Const.CCOUNT ? Const.RED : Const.BLUE );
			
			  // Read the stance, what the child is holding and how much
			  // longer he's dazed.
			  token = in.next();
			  c.standing = token.equals( "S" );
			
			  c.holding_ant = c.holding;
			  token = in.next();
			  c.holding = token.charAt( 0 ) - 'a';
		
			  c.dazed = in.nextInt();
			  //#################### Reseta a criana aqui
			  
			  if (c.action == "catch" && c.holding>c.holding_ant)	// Se ao anterior era pegar, e pegou
				  pegadas++;
			  if (c.eh_alvo && c.holding>c.holding_ant && c.holding>=4 &&(c.holding_ant==Const.HOLD_S1 || c.holding_ant==Const.HOLD_S2 || c.holding_ant==Const.HOLD_EMPTY))	// Se ao anterior era pegar, e pegou
				  ele_pegador++;
			  
			  c.eh_alvo=false;
			  c.action = "idle";
			  c.dest = null;

			}
		      }
		      
		      // Marca minhas crianas no mapa 
		      for ( int i = 0; i < Const.CCOUNT; i++ ) {
			Child c = cList[ i ];
			if ( c.pos.x >= 0 ) 
			  ground[ c.pos.x ][ c.pos.y ] = Const.GROUND_CHILD_MINHA;
		      }
		      // Marca crianas inimigas no mapa 
		      for ( int i = Const.CCOUNT; i < Const.CCOUNT * 2; i++ ) {
			Child c = cList[ i ];
			if ( c.pos.x >= 0 ) 
			  ground[ c.pos.x ][ c.pos.y ] = Const.GROUND_CHILD_DELE;
			if (c.dazed==3)
				acertos++;
		      }
		      
		      atribui_vitima(cList);
		      
		      // Decide what each child should do *********************
		      for ( int i = 0; i < Const.CCOUNT; i++ ) {
			Child c = cList[ i ];
		
			if ( c.dazed == 0 ) {
				
				// See if the child needs a new destination.
				while ( (runTimer[ i ] <= 0 || runTarget[ i ].equals( c.pos )) || !dispersa(runTarget[ i ],turnNum) ) {
				//while ( (runTimer[ i ] <= 0 || runTarget[ i ].equals( c.pos )) ) {
					runTarget[ i ].setLocation( rnd.nextInt( Const.SIZE ),
					rnd.nextInt( Const.SIZE ) );
					runTimer[ i ] = 1 + rnd.nextInt( 10 );
				}
				Point ajuda = socorro_2(c,cList);
				if (ajuda!=null){
					runTarget[ i ].setLocation( ajuda.x,ajuda.y );	
					runTimer[ i ] = 1;
				//	System.err.println(i+" Indo ajudar");
				}
				
				if (turnNum==timeToGo && i != 2)
					c.constroi_boneco = c.controi_boneco(height,ground);
				if (turnNum>=3 && turnNum<=timeToGo-1 && i == 1)
					c.constroi_boneco = c.controi_boneco(height,ground);
				
				//	Conta qtos estao construindo boneco nesse moumento
				int construindo_boneco=0;
				for ( int j = 0; j < Const.CCOUNT; j++ )
					if (cList[ j ].constroi_boneco>0)
						construindo_boneco++;
				

				
				if (!c.roubando()){	// Faz o ato de roubar a cabea
				   
				  //  if(!c.catcher(cList,c.defencivo(score)) ){
				      if(!c.catcher(cList,c.defencivo(score,fator)) ){
					    
					if (c.holding == Const.HOLD_S2 || c.holding == Const.HOLD_S3)	//Cancela a construo de bonecos
						c.constroi_boneco=0;
					if ( c.holding == Const.HOLD_P1 && c.constroi_boneco==0 )
						c.action = "crush";
					    
				// Se ele ta construindo, no interrompe.
				// Se tem vitima ou
				// Tem os 3 construindo no inicio,  hunter

					if((c.victimFound || construindo_boneco==3) && c.constroi_boneco==0 && c.rouba==null && turnNum>timeToGo){  //Hunter
					//	System.err.println(i+" Hunter");
						c.constroi_boneco = 0;	
						
						// Try to acquire a snowball if we need one.
						if ( c.holding != Const.HOLD_S1 && c.holding != Const.HOLD_S2 && c.holding != Const.HOLD_S3 ) {
							// Crush into a snowball, if we have snow.
							if ( c.holding == Const.HOLD_P1 ) {
								c.action = "crush";
							} else {
								if (c.acha_bolinha())
									c.pega_neve();
								else
									if (c.acha_neve(height,ground))
										c.pega_neve();
								
							}
						} else  {
							
							if (c.victimFound){
								c.temNeve=c.conta_neve();
								
								if (c.victimNext && c.temNeve==0)
									c.anda_pouquinho(cList,true);
								else if (c.victimNext && c.temNeve<2 && cList[c.alvo].dazed>1)
									c.anda_pouquinho(cList,true);	
								else
									c.atira_no_alvo(cList);								
							}
						}
						
					}else{	
						if(!c.mula_sem_cabeca()){		// Procura e poem cabea nas mulas
							c.rouba = ladrao(c);		// <= 52, seta boneco pra roubar
							if(c.rouba!=null && c.constroi_boneco==0){
								

								double dst = dist_eucli(c.pos,c.rouba);
							//	System.err.println(i+" Ladrao, alvo: "+c.rouba+","+dst);
								if (dst<=1.5){		// Se ta encostado, rouba							
									
									if ( c.holding == Const.HOLD_P1 ) {
										c.action = "crush";
									} else {
										if (c.rouba_boneco()){
											c.pega_neve();
											//System.err.println(i+" Roubando XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX "+c.rouba);
										}
									}								
								}else{							
									c.action="idle";
									runTarget[ i ]=c.rouba;
									runTimer[ i ] = 1;
									stopNextTo = true;
									bonecos_inimigos.remove(bonecos_inimigos.indexOf(c.rouba));
								//	System.err.println(" index "+bonecos_inimigos.indexOf(c.rouba));
									if (dst>4){		// Se >16, ele vai em direo, mas no fixa
										c.rouba=null;
									}
								}
							}else{	// Planter
								if (turnNum>timeToGo){
									if(!(turnNum>168) && !area_dominada_2(c) && (construindo_boneco==0 ||c.constroi_boneco>0)){//	> 50	Constroi boneco
									//	System.err.println(i+" Planter");
										c.constroi_boneco = c.controi_boneco(height,ground);						
									}else{
										//System.err.println(i+" Area dominada");
										if ( c.holding == Const.HOLD_EMPTY  )
											if (c.acha_neve(height,ground))
												c.pega_neve();
										
										if ( c.holding == Const.HOLD_P2 || c.holding == Const.HOLD_P3 ||c.holding == Const.HOLD_M || c.holding == Const.HOLD_L){	//Se tiver segurando uma bolinha, solta
											c.acha_lugar_boneco(height,ground,true,true);			    
											c.action = "drop";
										}
										
										c.constroi_boneco = 0;
									}
								}
							}
						}				
					}
				}
				}
				
				// Se no vai fazer nada, corre
				if ( c.action.equals( "idle" ) ) {
					if ( !c.standing)
						c.action = "stand";
					else{
						//moveToward( c, runTarget[ i ],false );
						moveToward_2( c, runTarget[ i ],stopNextTo);
						runTimer[ i ]--;
					}
				}
			}else{

				if (c.constroi_boneco==1)	// Se ta na fase inicial da construo
					c.constroi_boneco=0;	//Aborta
				if ( c.dazed == 3 ){
					tontos++;
				}
					
			}
			      
			      /** Write out the child's move */
			      if ( c.dest == null ) {
				      System.out.println( c.action );
			      } else {
				      if (c.action!="throw")
					      ground[ c.dest.x ][ c.dest.y ] = Const.GROUND_OCUPADO;
				      System.out.println( c.action + " " + c.dest.x + " " + c.dest.y );
			      }
			      
		      }
		      
		      turnNum = in.nextInt();
		    }
  }



//################################# Funes pouco usadas ##################
public static int round( double x ) {
	if ( x < 0 ) {
		return -(int)(Math.round( -x ));
	}
	return (int)(Math.round( x ));
}

/** Return the value of x, clamped to the [ a, b ] range. */
static int clamp( int x, int a, int b ) {
	if ( x < a )
		return a;
	if ( x > b )
		return b;
	return x;
}
  
  private static int distancia_3(Child a,Child b){
	if(b.pos.x<0 || a.dazed>0)
		return 25; 
	  
	int dx = b.pos.x - a.pos.x;
	int dy = b.pos.y - a.pos.y;
	

	int Mul = 3;
	
	for (int i=5;i>=2;i--){
		int ddx = dx*i;
		int ddy = dy*i;
		if (ddx*ddx+ddy*ddy<Const.MAX_THROW){
			Mul=i;
			break;
		}
	}
	
	boolean aux;
		    
	int finalX;
	int finalY;

	aux=a.standing;		//Salva estado
	int mod=0;
	
	if((a.holding == Const.HOLD_S2 || a.holding == Const.HOLD_S3) && b.dazed>1){	//Modificador
		mod++;
		//System.err.println("################## MOD ############");
	}
	
	finalX=a.pos.x+dx*Mul;
	finalY=a.pos.y+dy*Mul;
	
	
	a.standing=false;	// Tenta agachado
	if ( Child.throw_perfeito_2(a,new Point( finalX,finalY),b) < Const.MAX_THROW ) {
		a.standing=aux;	    
		return 1+mod;
	}
	
	a.standing=aux;
	return 25; 		// Inalcansvel		    

  }
  
    private static double dist_eucli(Point a,Point b){
	int dx = a.x - b.x;
	int dy = a.y - b.y;
	
	  return Math.sqrt((dx * dx) + (dy * dy));  
  }
  
  static boolean nextTo(int x1, int y1, int x2, int y2) {
    if (x1 == x2 && y1 == y2) {
        return false; // on != next to
    } else {
        return x2 >= x1 - 1 && x2 <= x1 + 1 &&
                y2 >= y1 - 1 && y2 <= y1 + 1;
    }
}


}	
